=== debian/changelog ===
poco (1.14.2-3) unstable; urgency=medium

  * QA upload
  * Disable Foundation tests (Closes: #1115538)

 -- Bastian Germann <bage@debian.org>  Tue, 23 Sep 2025 17:13:41 +0200

poco (1.14.2-2) unstable; urgency=medium

  * QA upload
  * Rephrase pkg description that triggers blhc

 -- Bastian Germann <bage@debian.org>  Wed, 17 Sep 2025 11:42:07 +0200

poco (1.14.2-1) experimental; urgency=medium

  * QA upload
  * New upstream version 1.14.2 (Closes: #1097628, #1108157, CVE-2025-6375)
  * Rename lib pkgs according to SOVERSION

 -- Bastian Germann <bage@debian.org>  Sat, 13 Sep 2025 23:42:38 +0200
