=== debian/control ===
Source: poco
Priority: optional
Maintainer: Debian QA Group <packages@qa.debian.org>
Build-Depends: debhelper-compat (= 13),
               dpkg-dev (>= 1.22.5),
               cmake,
               libexpat1-dev,
               default-libmysqlclient-dev,
               libpcre2-dev,
               libsqlite3-dev,
               libpq-dev,
               libssl-dev,
               libutf8proc-dev,
               unixodbc-dev,
               zlib1g-dev
Standards-Version: 4.6.0
Rules-Requires-Root: no
Section: libs
Homepage: https://pocoproject.org/
Vcs-Browser: https://salsa.debian.org/debian/poco
Vcs-Git: https://salsa.debian.org/debian/poco.git

Package: libpoco-dev
Section: libdevel
Architecture: any
Depends: ${misc:Depends},
         libpocoactiverecord112 (= ${binary:Version}),
         libpococrypto112 (= ${binary:Version}),
         libpocodata112 (= ${binary:Version}),
         libpocoencodings112 (= ${binary:Version}),
         libpocofoundation112 (= ${binary:Version}),
         libpocojson112 (= ${binary:Version}),
         libpocojwt112 (= ${binary:Version}),
         libpocodatamysql112 (= ${binary:Version}),
         libpocodatapostgresql112 (= ${binary:Version}),
         libpocomongodb112 (= ${binary:Version}),
         libpoconet112 (= ${binary:Version}),
         libpoconetssl112 (= ${binary:Version}),
         libpocodataodbc112 (= ${binary:Version}),
         libpocodatasqlite112 (= ${binary:Version}),
         libpocoprometheus112 (= ${binary:Version}),
         libpocoredis112 (= ${binary:Version}),
         libpocoutil112 (= ${binary:Version}),
         libpocoxml112 (= ${binary:Version}),
         libpocozip112 (= ${binary:Version}),
         libexpat1-dev,
         default-libmysqlclient-dev,
         libpcre2-dev,
         libsqlite3-dev,
         libssl-dev,
         zlib1g-dev
Description: C++ Portable Components (POCO) Development files
 The POCO C++ Libraries are a collection of open source C++ class libraries
 that simplify and accelerate the development of network-centric, portable
 applications in C++. The libraries integrate perfectly with the C++ Standard
 Library and fill many of the functional gaps left open by it.
 .
 POCO is built strictly using standard ANSI/ISO C++, including the standard
 library. The contributors attempt to find a good balance between using advanced
 language features and keeping the classes comprehensible and the code clean,
 consistent and easy to maintain.
 .
 POCO consists of four core libraries, and a number of add-on libraries. The
 core libraries are Foundation, XML, Util and Net. Two of the add-on libraries
 are NetSSL, providing SSL support for the network classes in the Net library,
 and Data, a library for uniformly accessing different SQL databases.

Package: libpocoactiverecord112
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: C++ Portable Components (POCO) ActiveRecord library
 The POCO C++ Libraries are a collection of open source C++ class libraries
 that simplify and accelerate the development of network-centric, portable
 applications in C++. The libraries integrate perfectly with the C++ Standard
 Library and fill many of the functional gaps left open by it.
 .
 POCO is built strictly using standard ANSI/ISO C++, including the standard
 library. The contributors attempt to find a good balance between using advanced
 language features and keeping the classes comprehensible and the code clean,
 consistent and easy to maintain.
 .
 This package provides the POCO ActiveRecord library.

Package: libpococrypto112
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: C++ Portable Components (POCO) Crypto library
 The POCO C++ Libraries are a collection of open source C++ class libraries
 that simplify and accelerate the development of network-centric, portable
 applications in C++. The libraries integrate perfectly with the C++ Standard
 Library and fill many of the functional gaps left open by it.
 .
 POCO is built strictly using standard ANSI/ISO C++, including the standard
 library. The contributors attempt to find a good balance between using advanced
 language features and keeping the classes comprehensible and the code clean,
 consistent and easy to maintain.
 .
 This package provides the POCO Crypto library.

Package: libpocodata112
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: C++ Portable Components (POCO) Data library
 The POCO C++ Libraries are a collection of open source C++ class libraries
 that simplify and accelerate the development of network-centric, portable
 applications in C++. The libraries integrate perfectly with the C++ Standard
 Library and fill many of the functional gaps left open by it.
 .
 POCO is built strictly using standard ANSI/ISO C++, including the standard
 library. The contributors attempt to find a good balance between using advanced
 language features and keeping the classes comprehensible and the code clean,
 consistent and easy to maintain.
 .
 This package provides the POCO Data library.

Package: libpocomongodb112
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: C++ Portable Components (POCO) Data MongoDB library
 The POCO C++ Libraries are a collection of open source C++ class libraries
 that simplify and accelerate the development of network-centric, portable
 applications in C++. The libraries integrate perfectly with the C++ Standard
 Library and fill many of the functional gaps left open by it.
 .
 POCO is built strictly using standard ANSI/ISO C++, including the standard
 library. The contributors attempt to find a good balance between using advanced
 language features and keeping the classes comprehensible and the code clean,
 consistent and easy to maintain.
 .
 This package provides the POCO MongoDB library.

Package: libpocodatamysql112
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: C++ Portable Components (POCO) Data MySQL library
 The POCO C++ Libraries are a collection of open source C++ class libraries
 that simplify and accelerate the development of network-centric, portable
 applications in C++. The libraries integrate perfectly with the C++ Standard
 Library and fill many of the functional gaps left open by it.
 .
 POCO is built strictly using standard ANSI/ISO C++, including the standard
 library. The contributors attempt to find a good balance between using advanced
 language features and keeping the classes comprehensible and the code clean,
 consistent and easy to maintain.
 .
 This package provides the POCO Data MySQL library.

Package: libpocodatapostgresql112
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: C++ Portable Components (POCO) Data PostgreSQL library
 The POCO C++ Libraries are a collection of open source C++ class libraries
 that simplify and accelerate the development of network-centric, portable
 applications in C++. The libraries integrate perfectly with the C++ Standard
 Library and fill many of the functional gaps left open by it.
 .
 POCO is built strictly using standard ANSI/ISO C++, including the standard
 library. The contributors attempt to find a good balance between using advanced
 language features and keeping the classes comprehensible and the code clean,
 consistent and easy to maintain.
 .
 This package provides the POCO Data PostgreSQL library.

Package: libpocodataodbc112
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: C++ Portable Components (POCO) ODBC library
 The POCO C++ Libraries are a collection of open source C++ class libraries
 that simplify and accelerate the development of network-centric, portable
 applications in C++. The libraries integrate perfectly with the C++ Standard
 Library and fill many of the functional gaps left open by it.
 .
 POCO is built strictly using standard ANSI/ISO C++, including the standard
 library. The contributors attempt to find a good balance between using advanced
 language features and keeping the classes comprehensible and the code clean,
 consistent and easy to maintain.
 .
 This package provides the POCO Data ODBC library. In Debian, it is linked
 against unixODBC but also iODBC can be used instead.

Package: libpocodatasqlite112
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: C++ Portable Components (POCO) Data SQLite library
 The POCO C++ Libraries are a collection of open source C++ class libraries
 that simplify and accelerate the development of network-centric, portable
 applications in C++. The libraries integrate perfectly with the C++ Standard
 Library and fill many of the functional gaps left open by it.
 .
 POCO is built strictly using standard ANSI/ISO C++, including the standard
 library. The contributors attempt to find a good balance between using advanced
 language features and keeping the classes comprehensible and the code clean,
 consistent and easy to maintain.
 .
 This package provides the POCO Data SQLite library.

Package: libpocoencodings112
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: C++ Portable Components (POCO) Encodings library
 The POCO C++ Libraries are a collection of open source C++ class libraries
 that simplify and accelerate the development of network-centric, portable
 applications in C++. The libraries integrate perfectly with the C++ Standard
 Library and fill many of the functional gaps left open by it.
 .
 POCO is built strictly using standard ANSI/ISO C++, including the standard
 library. The contributors attempt to find a good balance between using advanced
 language features and keeping the classes comprehensible and the code clean,
 consistent and easy to maintain.
 .
 This package provides the POCO Encodings library.

Package: libpocofoundation112
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: C++ Portable Components (POCO) Foundation library
 The POCO C++ Libraries are a collection of open source C++ class libraries
 that simplify and accelerate the development of network-centric, portable
 applications in C++. The libraries integrate perfectly with the C++ Standard
 Library and fill many of the functional gaps left open by it.
 .
 POCO is built strictly using standard ANSI/ISO C++, including the standard
 library. The contributors attempt to find a good balance between using advanced
 language features and keeping the classes comprehensible and the code clean,
 consistent and easy to maintain.
 .
 This package provides the POCO Foundation library.

Package: libpocojson112
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: C++ Portable Components (POCO) JSON library
 The POCO C++ Libraries are a collection of open source C++ class libraries
 that simplify and accelerate the development of network-centric, portable
 applications in C++. The libraries integrate perfectly with the C++ Standard
 Library and fill many of the functional gaps left open by it.
 .
 POCO is built strictly using standard ANSI/ISO C++, including the standard
 library. The contributors attempt to find a good balance between using advanced
 language features and keeping the classes comprehensible and the code clean,
 consistent and easy to maintain.
 .
 This package provides the POCO JSON library.

Package: libpocojwt112
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: C++ Portable Components (POCO) JWT library
 The POCO C++ Libraries are a collection of open source C++ class libraries
 that simplify and accelerate the development of network-centric, portable
 applications in C++. The libraries integrate perfectly with the C++ Standard
 Library and fill many of the functional gaps left open by it.
 .
