=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

ifneq (,$(filter $(DEB_BUILD_ARCH),mipsel m68k))
	CXXFLAGS+=-g1
endif
ifeq (armel,$(DEB_HOST_ARCH))
	export DEB_LDFLAGS_MAINT_APPEND= -latomic
endif

%:
	dh $@ --buildsystem=cmake

override_dh_auto_configure:
	dh_auto_configure -- -DENABLE_TESTS=ON -DPOCO_UNBUNDLED=ON -DPOCO_DATA_NO_SQL_PARSER=ON
